<?php
/**
* $Id: db.php,v 1.8.2.2 2005/08/29 20:23:06 thorstenr Exp $
*
* The database abstraction factory
*
* @author       Thorsten Rinne <thorsten@phpmyfaq.de>
* @since        2003-02-24
* @copyright:   (c) 2003-2005 phpMyFAQ Team
*
* The contents of this file are subject to the Mozilla Public License
* Version 1.1 (the "License"); you may not use this file except in
* compliance with the License. You may obtain a copy of the License at
* http://www.mozilla.org/MPL/
*
* Software distributed under the License is distributed on an "AS IS"
* basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
* License for the specific language governing rights and limitations
* under the License.
*/

class db
{
    /**
    * Constructor
    */
    function db()
    {
        return $this->__construct();
    }
    function __construct()
    {
    }
    
    /**
     * Database factory
     *
     * @access  public
     * @author  Thorsten Rinne <thorsten@phpmyfaq.de>
     * @since   2005-01-02
     */
	function db_select($type)
    {
        $file = str_replace('\\', '/', __FILE__);
        $dir = substr($file, 0, strrpos($file, "/"));
		$dir .= "/";
		if (file_exists($dir.$type.".php")) {
			require_once($dir.$type.".php");
            switch ($type) {
                case 'mysql':   return new db_mysql();
                                break;
                case 'mysqli':  return new db_mysqli();
                                break;
                case 'pgsql':   return new db_pgsql();
                                break;
                case 'sybase':  return new db_sybase();
                                break;
                case 'mssql':   return new db_mssql();
                                break;
                case 'db2':     return new db_db2();
                                break;
                case 'sqlite':  return new db_sqlite();
                                break;
                // add more supported databases here
            }
		} else {
			trigger_error("Invalid Database Type", E_USER_ERROR);
        }
    }
}
?>
